<!-- 
	Name		:	GlobalSearchComponent
	Description	:	Search Account based on Account Name or Account Number or Speciality
					Search Geography based on ZIP code or City or State
	Parameter 	:	ID of input field component on which auto-complete applied
-->
<apex:component controller="GlobalSearchComponentCtrl">
	<!-- <apex:includeScript value="{!URLFOR($Resource.jqueryui18, 'js/jquery-1.7.1.min.js')}" />
	<apex:includeScript value="{!URLFOR($Resource.jqueryui18, 'js/jquery-ui-1.8.18.custom.min.js')}" /> -->
	<apex:stylesheet value="{!URLFOR($Resource.jqueryui18,'css/smoothness/jquery-ui-1.8.18.custom.css')}" />

	<!-- Attributes Required For Component -->
  	<apex:attribute name="autocomplete_textbox" description="The ID for the Autocomplete List Textbox." type="String" required="true"/>
  	
   	<!-- CSS Style -->
  	<style>
	    .ui-autocomplete-loading {background: white url({!$Resource.loadingIcon}) right center no-repeat;}
	</style>

  	<!-- Javascript -->
  	<script type="text/javascript" >
	    var j$ = jQuery.noConflict();
		
	    j$(document).ready(function()
	    {
	    	var sObjects;
	        var queryTerm;
	
	        j$(esc('{!JSENCODE(HTMLENCODE(autocomplete_textbox))}')).autocomplete({
	            minLength: 1,
	            source: function(request, response) {
	            	queryTerm = request.term;
	                GlobalSearchComponentCtrl.globalFind(request.term, function(result, event){
	                //GlobalSearchComponentCtrl.globalFindwithSoql(request.term, function(result, event){
	                    if(event.type == 'exception'){
							alert(event.message);
						}else{
							console.log('Result : '+result);
							sObjects = result;
		                    response(sObjects);
		                }
					});
	            },
	            minLength: 0,
	 			
	 			focus: function( event, ui ) {
	            	j$(esc('{!JSENCODE(HTMLENCODE(autocomplete_textbox))}')).val( ui.item.value);
	                return false;
	            },
	            
	            select: function( event, ui ) {
	            	//var entry = ui.item.value.split(',');
	            	j$(esc('{!JSENCODE(HTMLENCODE(autocomplete_textbox))}')).val(ui.item.value);
	            	//j$(esc('{!autocomplete_textbox}')).val(entry[0]);
					
					doGlobalSearch(); 
					if (event.keyCode == 13) { 
						event.preventDefault();
					}
					return false;
				},
	            change: function (event, ui) { },
				close: function(){
					// j$('#hidden').focus();
					console.log('closed');
	   			},
			})
	
	        .data( "autocomplete" )._renderItem = function( ul, item ) {
	        	var entry = item.value;
	        	entry = entry.replace( new RegExp( "(" + queryTerm + ")" , "gi" ), "<strong>$1</strong>" );
	
	            return j$( "<li></li>" )
				.data( "item.autocomplete", item )
	            .append( "<a>" + entry + "</a>")
				.appendTo( ul );
	        };
	    });
	
	    function esc(myid){
			return '#' + myid.replace(/(:|\.)/g,'\\\\$1');
	    }

	</script>
</apex:component>